HDU 2389 Rain on your Parade / HUST 1164 4 Rain on your Parade(二分图的最大匹配)
HDU 2389 Rain on your Parade / HUST 1164 4 Rain on your Parade(二分图的最大匹配)
Description
You’re giving a party in the garden of your villa by the sea. The party is a huge success, and everyone is here. It’s a warm, sunny evening, and a soothing wind sends fresh, salty air from the sea. The evening is progressing just as you had imagined. It could be the perfect end of a beautiful day.
But nothing ever is perfect. One of your guests works in weather forecasting. He suddenly yells, “I know that breeze! It means its going to rain heavily in just a few minutes!” Your guests all wear their best dresses and really would not like to get wet, hence they stand terrified when hearing the bad news.
You have prepared a few umbrellas which can protect a few of your guests. The umbrellas are small, and since your guests are all slightly snobbish, no guest will share an umbrella with other guests. The umbrellas are spread across your (gigantic) garden, just like your guests. To complicate matters even more, some of your guests can’t run as fast as the others.
Can you help your guests so that as many as possible find an umbrella before it starts to pour?
Given the positions and speeds of all your guests, the positions of the umbrellas, and the time until it starts to rain, find out how many of your guests can at most reach an umbrella. Two guests do not want to share an umbrella, however.
Input
The input starts with a line containing a single integer, the number of test cases.
Each test case starts with a line containing the time t in minutes until it will start to rain (1 <=t <= 5). The next line contains the number of guests m (1 <= m <= 3000), followed by m lines containing x- and y-coordinates as well as the speed si in units per minute (1 <= s i <= 3000) of the guest as integers, separated by spaces. After the guests, a single line contains n (1 <= n <= 3000), the number of umbrellas, followed by n lines containing the integer coordinates of each umbrella, separated by a space.
The absolute value of all coordinates is less than 10000.
Output
For each test case, write a line containing “Scenario #i:”, where i is the number of the test case starting at 1. Then, write a single line that contains the number of guests that can at most reach an umbrella before it starts to rain. Terminate every test case with a blank line.
Sample Input
2
1
2
1 0 3
3 0 3
2
4 0
6 0
1
2
1 1 2
3 3 2
2
2 2
4 4
Sample Output
Scenario #1:
2
Scenario #2:
2
Http
HDU:https://vjudge.net/problem/HDU-2389
HUSTT:https://vjudge.net/problem/HUST-1164
Source
二分图的最大匹配
题目大意
现在马上要下雨了,给出n个人和m把雨伞的坐标位置,以及每个人的奔跑速度,还有距离下雨的时间。每把雨伞只能供一人使用。求在下雨前最多有多少人可以拿到雨伞。
解决思路
这个题目一看就是二分图的最大匹配问题。但若直接把匈牙利算法往上一摆,会TLE。
为什么呢?好好看题:n,m<=3000。而原来我们做的题目都是n,m<=100或<=200的。所以这道题不能直接用匈牙利算法解决。
所以这道题我们要用到匈牙利算法的改进版:Hopcroft-Karp算法(一下简称HK算法)
我们知道,匈牙利算法时间效率不高的原因就是在一次匹配时只走一条增广边,每次都要重新找增广边,所以时间效率低。
那么,HK算法就是在每一次判断前,先用一个bfs预处理处理出多条增广边,下面先给出代码。
代码中的变量说明:
Dist:一个全局变量,保存当前最长的增广路的深度,方便及时退出bfs,同时也方便后面再进行Hungary时及时退出(后面会讲到)
Deep_x:人对应的点的深度(也就是到此点时的增广路长度),同时可以方便判断人i是否在这次bfs中走过了。这个变量在匈牙利算法中也会用到(后面会说到)
Deep_y:伞对应的点的深度(同上),也能判断伞是否在这次bfs中是否用过
Match_x:人所匹配的伞的编号
Match_y:伞所匹配的人的编号
E:从人->伞的边
其他变量的意义与题目一致
bool bfs()
{
queue<int> Q;//bfs要用的队列
while (!Q.empty())
Q.pop();
Dist=inf;//先置为inf
mem(Deep_x,-1);//先置为-1,表示还未经过
mem(Deep_y,-1);
for (int i=1;i<=m;i++)
if (Match_x[i]==-1)//若人i还未匹配,则将其加入队列(因为增广路的开始点是未匹配点)
{
Deep_x[i]=0;
Q.push(i);
}
while (!Q.empty())//因为有可能所有人都已经匹配,所以要把while判断写前面,以免出现RE
{
int u=Q.front();
Q.pop();
if (Deep_x[u]>Dist)//若发现当前选出的人u的深度已经大于能形成增广路的最大深度了,直接退出。这是一个很好的剪枝
break;
for (int i=0;i<E[u].size();i++)
{
int v=E[u][i];//选择伞v
if (Deep_y[v]==-1)//若伞v在这一次bfs中还未走过
{
Deep_y[v]=Deep_x[u]+1;//首先更新伞v的深度,同时表示已经处理过伞v了
if (Match_y[v]==-1)//当伞v还未匹配时,说明找到了一条增广路,这时更新最长增广路的值Dist。因为是bfs,所以可以保证越在后面出来的Deep值越大,所以不用加max
{
Dist=Deep_y[v];
}
else//如果伞v已经匹配,则处理其对应的匹配的人,并将这个人加入队列
{
Deep_x[Match_y[v]]=Deep_y[v]+1;
Q.push(Match_y[v]);
}
}
}
}
//cout<<"Dist "<<Dist<<endl;
if (Dist==inf)//这表示没有增广路了,说明算法执行完毕,返回0
return 0;
return 1;
}
总计一下,这个bfs过程的意义就是增广多条增广路,方便后面匈牙利算法。
那么接下来就是修改匈牙利算法了。还是先给出代码。
bool Hungary(int u)
{
for (int i=0;i<E[u].size();i++)
{
int v=E[u][i];
if ((vis[v]==0)&&(Deep_x[u]+1==Deep_y[v]))//注意,这里用到了bfs计算出来的Deep数组,这可以用来判断当前选的伞v是否是我们在dfs中选的那条增广路,有效剪枝
{
vis[v]=1;
if ((Match_y[v]!=-1)&&(Deep_y[v]==Dist))//若发现当前伞v的Deep已经和最大增广路长度一样,并且伞v已匹配,那么再递归向下找是无意义的,直接continue
continue;
if ((Match_y[v]==-1)||(Hungary(Match_y[v])))
{
Match_x[u]=v;//注意,因为添加了人对应匹配的伞这个变量,所以也要更新(这在之前的匈牙利中是没有的)
Match_y[v]=u;
return 1;
}
}
}
return 0;
}
最后总计一下HK算法的主要流程就是:
先找出多条不相交的增广路。
用匈牙利算法进行匹配。
(如有不正确之处还请各路神犇指教)
代码(后面附上了TLE的纯匈牙利算法)
#include<iostream>
#include<cstdio>
#include<cstdlib>
#include<cstring>
#include<algorithm>
#include<vector>
#include<queue>
using namespace std;
#define ll long long
#define mem(Arr,x) memset(Arr,x,sizeof(Arr))
const int maxN=4000;
const int inf=2147483647;
int n,m;
int Time;//距离下雨的时间
int Dist;//下面这些变量的意义在上文已经讲过啦
vector<int> E[maxN];
int Match_x[maxN];
int Match_y[maxN];
bool vis[maxN];
int Deep_x[maxN];
int Deep_y[maxN];
int X[maxN];//人的X坐标
int Y[maxN];
int Speed[maxN];//人的速度
int read();
bool Judge(int u,int v,int num);
bool bfs();
bool Hungary(int u);
int main()
{
int T;
T=read();
for (int ti=1;ti<=T;ti++)
{
Time=read();
m=read();
for (int i=1;i<=m;i++)
E[i].clear();
for (int i=1;i<=m;i++)
{
X[i]=read();
Y[i]=read();
Speed[i]=read();
}
n=read();
for (int i=1;i<=n;i++)
{
int x,y;
x=read();
y=read();
for (int j=1;j<=m;j++)
if (Judge(x,y,j))
{
E[j].push_back(i);
}
}
int Ans=0;
mem(Match_x,-1);
mem(Match_y,-1);
while (bfs())//HK算法
{
mem(vis,0);
for (int i=1;i<=m;i++)
if (Match_x[i]==-1)
if (Hungary(i))
Ans++;
}
printf("Scenario #%d:\n%d\n\n",ti,Ans);
}
return 0;
}
int read()//读入优化
{
int x=0;
int k=1;
char ch=getchar();
while (((ch<'0')||(ch>'9'))&&(ch!='-'))
ch=getchar();
if (ch=='-')
{
k=-1;
ch=getchar();
}
while ((ch<='9')&&(ch>='0'))
{
x=x*10+ch-48;
ch=getchar();
}
return x*k;
}
bool Judge(int u,int v,int num)//判断某个人是否可以跑到某把伞
{
long long Dist=(long long)((X[num]-u))*(X[num]-u)+(long long)((Y[num]-v))*(Y[num]-v);
long long D=(long long)(Time)*Speed[num];
if (D*D>=Dist)
return 1;
return 0;
}
bool bfs()
{
queue<int> Q;//bfs要用的队列
while (!Q.empty())
Q.pop();
Dist=inf;//先置为inf
mem(Deep_x,-1);//先置为-1,表示还未经过
mem(Deep_y,-1);
for (int i=1;i<=m;i++)
if (Match_x[i]==-1)//若人i还未匹配,则将其加入队列(因为增广路的开始点是未匹配点)
{
Deep_x[i]=0;
Q.push(i);
}
while (!Q.empty())//因为有可能所有人都已经匹配,所以要把while判断写前面,以免出现RE
{
int u=Q.front();
Q.pop();
if (Deep_x[u]>Dist)//若发现当前选出的人u的深度已经大于能形成增广路的最大深度了,直接退出。这是一个很好的剪枝
break;
for (int i=0;i<E[u].size();i++)
{
int v=E[u][i];//选择伞v
if (Deep_y[v]==-1)//若伞v在这一次bfs中还未走过
{
Deep_y[v]=Deep_x[u]+1;//首先更新伞v的深度,同时表示已经处理过伞v了
if (Match_y[v]==-1)//当伞v还未匹配时,说明找到了一条增广路,这时更新最长增广路的值Dist。因为是bfs,所以可以保证越在后面出来的Deep值越大,所以不用加max
{
Dist=Deep_y[v];
}
else//如果伞v已经匹配,则处理其对应的匹配的人,并将这个人加入队列
{
Deep_x[Match_y[v]]=Deep_y[v]+1;
Q.push(Match_y[v]);
}
}
}
}
//cout<<"Dist "<<Dist<<endl;
if (Dist==inf)//这表示没有增广路了,说明算法执行完毕,返回0
return 0;
return 1;
}
bool Hungary(int u)
{
for (int i=0;i<E[u].size();i++)
{
int v=E[u][i];
if ((vis[v]==0)&&(Deep_x[u]+1==Deep_y[v]))//注意,这里用到了bfs计算出来的Deep数组,这可以用来判断当前选的伞v是否是我们在dfs中选的那条增广路,有效剪枝
{
vis[v]=1;
if ((Match_y[v]!=-1)&&(Deep_y[v]==Dist))//若发现当前伞v的Deep已经和最大增广路长度一样,并且伞v已匹配,那么再递归向下找是无意义的,直接continue
continue;
if ((Match_y[v]==-1)||(Hungary(Match_y[v])))
{
Match_x[u]=v;//注意,因为添加了人对应匹配的伞这个变量,所以也要更新(这在之前的匈牙利中是没有的)
Match_y[v]=u;
return 1;
}
}
}
return 0;
}
/* 匈牙利算法,TLE
#include<iostream>
#include<cstdio>
#include<cstdlib>
#include<cstring>
#include<algorithm>
#include<vector>
using namespace std;
const int maxN=4000;
const int inf=2147483647;
int n,m;
vector<int> E[maxN];
bool vis[maxN];
int Match[maxN];
int GuestX[maxN];
int GuestY[maxN];
int Speed[maxN];
int read();
bool Hungary(int u);
int main()
{
int T;
int Time;
cin>>T;
for (int ti=1;ti<=T;ti++)
{
cin>>Time;
cin>>m;
for (int i=1;i<=m;i++)
E[i].clear();
for (int i=1;i<=m;i++)
{
GuestX[i]=read();
GuestY[i]=read();
Speed[i]=read();
Speed[i]=Speed[i]*Time;
}
int x,y;
cin>>n;
for (int i=1;i<=n;i++)
{
x=read();
y=read();
for (int j=1;j<=m;j++)
{
int Dist=(x-GuestX[j])*(x-GuestX[j])+(y-GuestY[j])*(y-GuestY[j]);
if (Speed[i]*Speed[i]>=Dist)
E[j].push_back(i);
}
}
int Ans=0;
memset(Match,-1,sizeof(Match));
for (int i=1;i<=m;i++)
{
memset(vis,0,sizeof(vis));
if (Hungary(i))
{
Ans++;
}
}
printf("Scenario #%d:\n%d\n\n",ti,Ans);
//cout<<Ans<<endl;
}
}
int read()
{
int x=0;
int k=1;
char ch=getchar();
while (((ch<'0')||(ch>'9'))&&(ch!='-'))
ch=getchar();
if (ch=='-')
{
k=-1;
ch=getchar();
}
while ((ch<='9')&&(ch>='0'))
{
x=x*10+ch-48;
ch=getchar();
}
return x*k;
}
bool Hungary(int u)
{
for (int i=0;i<E[u].size();i++)
{
int v=E[u][i];
if (vis[v]==0)
{
vis[v]=1;
if ((Match[v]==-1)||(Hungary(Match[v])))
{
Match[v]=u;
return 1;
}
}
}
return 0;
}
*/
HDU 2389 Rain on your Parade / HUST 1164 4 Rain on your Parade(二分图的最大匹配)的更多相关文章
- HDU 2389 ——Rain on your Parade——————【Hopcroft-Karp求最大匹配、sqrt(n)*e复杂度】
Rain on your Parade Time Limit:3000MS Memory Limit:165535KB 64bit IO Format:%I64d & %I64 ...
- HDU 2444 The Accomodation of Students 二分图判定+最大匹配
题目来源:HDU 2444 The Accomodation of Students 题意:n个人能否够分成2组 每组的人不能相互认识 就是二分图判定 能够分成2组 每组选一个2个人认识能够去一个双人 ...
- HDU 2389 Rain on your Parade(二分匹配,Hopcroft-Carp算法)
Rain on your Parade Time Limit: 6000/3000 MS (Java/Others) Memory Limit: 655350/165535 K (Java/Ot ...
- (匹配 Hopcroft-Karp算法)Rain on your Parade -- Hdu --2389
链接: http://acm.hdu.edu.cn/showproblem.php?pid=2389 不能用匈牙利,会TEL的,用Hopcroft-Karp Hopcroft-Karp课件 以前是寻找 ...
- HDU 2389 Rain on your Parade
大意:在一个二维坐标系上有nx个人和ny把伞,每个人都有自己的移动速度,问有多少人可以再 time 时间内移动到不同的雨伞处(不允许两个人共用一把伞). 输入数据: 第一行是一个T代表T组测试数据 ...
- F - Rain on your Parade - hdu 2389(二分图匹配,Hk算法)
题意:给一些人和一些伞的坐标,然后每个人都有一定的速度,还有多少时间就会下雨,问最多能有多少人可以拿到伞. 分析:题意很明确,可以用每个人和伞判断一下是否能够达到,如果能就建立一个联系.不过这道题的数 ...
- HDU 2389 Rain on your Parade 最大匹配(模板题)【HK算法】
<题目链接> 题目大意:有m个宾客,n把雨伞,预计时间t后将会下大雨,告诉你每个宾客的位置和速度,每把雨伞的位置,问你最多几个宾客能够拿到伞. 解题分析: 本题就是要我们求人与伞之间的最大 ...
- Rain on your Parade HDU - 2389 (hc板题)
在客人能够拿到的伞与客人之间建边 跑hc就好了.... 看看别人的:https://blog.csdn.net/wall_f/article/details/8248350 #include < ...
- Hdu 2389 二分匹配
题目链接 Rain on your Parade Time Limit: 6000/3000 MS (Java/Others) Memory Limit: 655350/165535 K (Ja ...
随机推荐
- 利用 MUI开发app, 如何实现侧滑菜单及其主体部分上下滑动
利用mui开发APP 之侧滑菜单主内容滚动问题 MUI作为开发者常用的框架之一,其号称最接近原生APP体验的高性能前端框架.因此利用mui开发移动APP,可以为开发者提供很大的便利和接近原生的体验. ...
- ajax传数组到后台,后台springmvc接收数组参数
var ids= new Array(); $("input[class='detailCheck']:checked").each(function(i,k){ var ...
- 以太坊的crypto模块--以太坊源码学习
以太坊的crypto模块 该模块分为两个部分一个是实现sha3,一个是实现secp256k1(这也是比特币中使用的签名算法). 需要说明的是secp256k1有两种实现方式,一种是依赖libsecp2 ...
- 高性能队列Disruptor系列1--传统队列的不足
在前一篇文章Java中的阻塞队列(BlockingQueue)中介绍了Java中的阻塞队列.从性能上我们能得出一个结论:数组优于链表,CAS优于锁.那么有没有一种队列,通过数组的方式实现,而且采用无锁 ...
- 关于Atlassian无法注册的问题,请看过来
好多童鞋在用团队构建工具git的时候,必然用到git的可视化工具sourceTree来管理项目一些操作,那么当我们下载完sourTree的时候,会有一个选择,已有账户登录还是免费账户,免费账户只有三十 ...
- 使用 bufferedreader 的好处
简单的说,一次IO操作,读取一个字节也是读取,读取8k个字节也是读取,两者花费时间相差不多.而一次IO的来回操作却要耗费大量时间.好比是一辆大型汽车(设装100人),要去车站接人到公司,接一个人也是接 ...
- [0] MVC&MVP&MVVM差异点
MVC: 用户的请求首先会到达Controller,由Controller从Model获取数据,选择合适的View,把处理结果呈现到View上: MVP: 用户的请求首先会到达View,View传递请 ...
- angular js 和 dajango 标签{{}} 冲突
问题描述: 如果在django的模板中使用{{ }},不会被angularjs 识别. 解决办法: >1.5 的django中,将需要angularjs解释的{{expression}}放在 v ...
- HTTP协议 URL
http(超文本传输协议)是一个基于请求与响应模式的.无状态的.应用层的协议,常基于TCP的连接方式,HTTP1.1版本中给出一种持续连接的机制,绝大多数的Web开发,都是构建在HTTP协议之上的We ...
- [css 实践篇] CSS box-orient
定义和用法 box-orient 属性规定框的子元素应该被水平或垂直排列. 提示:水平框中的子元素从左向右进行显示,而垂直框的子元素从上向下进行显示.不过,box-direction 和 box-or ...